using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace Columns
{
    public class CustomColumn: GridViewBoundColumnBase
    {
        public static readonly DependencyProperty CheckBoxStyleProperty = DependencyProperty.Register(
            nameof(CheckBoxStyle), typeof(Style), typeof(CustomColumn), new PropertyMetadata(default(Style)));

        public Style CheckBoxStyle
        {
            get => (Style)GetValue(CheckBoxStyleProperty);
            set => SetValue(CheckBoxStyleProperty, value);
        }

        public override FrameworkElement CreateCellElement(GridViewCell cell, object dataItem)
        {
            cell.IsHitTestVisible = false;

            if (cell.Content is CheckBox checkBox) return checkBox;

            var binding = new Binding { Source = cell.ParentRow, Path = new PropertyPath("IsSelected", null!) };
            checkBox = new CheckBox { Style = CheckBoxStyle };
            checkBox.SetBinding(ToggleButton.IsCheckedProperty, binding);
            return checkBox;
        }
    }
}