using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace Columns
{
    public class Data
    {
        public static ObservableCollection<Row> Items => new ObservableCollection<Row>()
        {
            new Row("1", "12", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("2", "2", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("3", "122", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("4", "132", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("5", "42", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("6", "52", "Group1", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("7", "62", "Group2", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("8", "82", "Group2", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("9", "92", "Group2", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("10", "127", "Group3", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("11", "126", "Group4", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("12", "125", "Group3", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),
            new Row("13", "124", "Group3", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6"),

        };
    }

    public sealed record Row(string Id, string SortId, string GroupId, string Col1, string Col2, string Col3, string Col4, string Col5, string Col6) 
        : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler? PropertyChanged;

        private void OnPropertyChanged([CallerMemberName] string? propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        private bool SetField<T>(ref T field, T value, [CallerMemberName] string? propertyName = null)
        {
            if (EqualityComparer<T>.Default.Equals(field, value)) return false;
            field = value;
            OnPropertyChanged(propertyName);
            return true;
        }
    }
}